commit e7fd8e978ec101a6ce9c92c72d38f7bdff30b2c5
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Wed Jul 28 18:43:15 2021

    ubsan: Fix ICEs with DECL_REGISTER tests [PR101624]
    
    The following testcase ICEs, because the base is a CONST_DECL for
    the Fortran parameter, and ubsan/sanopt uses DECL_REGISTER macro on it.
     /* In VAR_DECL and PARM_DECL nodes, nonzero means declared `register'.  */
     #define DECL_REGISTER(NODE) (DECL_WRTL_CHECK (NODE)->decl_common.decl_flag_0)
    while CONST_DECL doesn't satisfy DECL_WRTL_CHECK.
    
    The following patch checks explicitly for VAR_DECL/PARM_DECL/RESULT_DECL
    only before using DECL_REGISTER, assumes other decls aren't DECL_REGISTER.
    Not really sure about RESULT_DECL but it at least satisfies DECL_WRTL_CHECK...
    
    2021-07-28  Jakub Jelinek  <jakub@redhat.com>
    
            PR middle-end/101624
            * ubsan.c (maybe_instrument_pointer_overflow,
            instrument_object_size): Only test DECL_REGISTER on VAR_DECLs,
            PARM_DECLs or RESULT_DECLs.
            * sanopt.c (maybe_optimize_ubsan_ptr_ifn): Likewise.
    
            * gfortran.dg/ubsan/ubsan.exp: New file.
            * gfortran.dg/ubsan/pr101624.f90: New test.
    
    (cherry picked from commit 49e28c02a95a4bee981e69a80950309869580151)

diff --git a/gcc/sanopt.c b/gcc/sanopt.c
index 41f20c35518..2910e33c1cc 100644
--- a/gcc/sanopt.c
+++ b/gcc/sanopt.c
@@ -492,7 +492,10 @@ maybe_optimize_ubsan_ptr_ifn (sanopt_ctx *ctx, gimple *stmt)
 				  &unsignedp, &reversep, &volatilep);
       if ((offset == NULL_TREE || TREE_CODE (offset) == INTEGER_CST)
 	  && DECL_P (base)
-	  && !DECL_REGISTER (base)
+	  && ((!VAR_P (base)
+	       && TREE_CODE (base) != PARM_DECL
+	       && TREE_CODE (base) != RESULT_DECL)
+	      || !DECL_REGISTER (base))
 	  && pbitpos.is_constant (&bitpos))
 	{
 	  offset_int expr_offset;
diff --git a/gcc/testsuite/gfortran.dg/ubsan/pr101624.f90 b/gcc/testsuite/gfortran.dg/ubsan/pr101624.f90
new file mode 100644
index 00000000000..51783c8ddad
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/ubsan/pr101624.f90
@@ -0,0 +1,13 @@
+! PR middle-end/101624
+! { dg-do compile }
+! { dg-options "-O2 -fsanitize=undefined" }
+
+complex function foo (x)
+  complex, intent(in) :: x
+  foo = aimag (x)
+end
+program pr101624
+  complex, parameter :: a = (0.0, 1.0)
+  complex :: b, foo
+  b = foo (a)
+end
diff --git a/gcc/testsuite/gfortran.dg/ubsan/ubsan.exp b/gcc/testsuite/gfortran.dg/ubsan/ubsan.exp
new file mode 100644
index 00000000000..e44d946c4a0
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/ubsan/ubsan.exp
@@ -0,0 +1,38 @@
+# Copyright (C) 2021 Free Software Foundation, Inc.
+#
+# This file is part of GCC.
+#
+# GCC is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3, or (at your option)
+# any later version.
+#
+# GCC is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GCC; see the file COPYING3.  If not see
+# <http://www.gnu.org/licenses/>.
+
+# GCC testsuite for gfortran that checks undefined behavior sanitizer.
+
+# Load support procs.
+load_lib gfortran-dg.exp
+load_lib ubsan-dg.exp
+
+
+# Initialize `dg'.
+dg-init
+ubsan_init
+
+# Main loop.
+if [check_effective_target_fsanitize_undefined] {
+    gfortran-dg-runtest [lsort \
+       [glob -nocomplain $srcdir/$subdir/*.\[fF\]{,90,95,03,08} ] ] "" ""
+}
+
+# All done.
+ubsan_finish
+dg-finish
diff --git a/gcc/ubsan.c b/gcc/ubsan.c
index 1089aef639f..8500d3de181 100644
--- a/gcc/ubsan.c
+++ b/gcc/ubsan.c
@@ -1443,7 +1443,10 @@ maybe_instrument_pointer_overflow (gimple_stmt_iterator *gsi, tree t)
   tree base;
   if (decl_p)
     {
-      if (DECL_REGISTER (inner))
+      if ((VAR_P (inner)
+	   || TREE_CODE (inner) == PARM_DECL
+	   || TREE_CODE (inner) == RESULT_DECL)
+	  && DECL_REGISTER (inner))
 	return;
       base = inner;
       /* If BASE is a fixed size automatic variable or
@@ -2115,7 +2118,10 @@ instrument_object_size (gimple_stmt_iterator *gsi, tree t, bool is_lhs)
   tree base;
   if (decl_p)
     {
-      if (DECL_REGISTER (inner))
+      if ((VAR_P (inner)
+	   || TREE_CODE (inner) == PARM_DECL
+	   || TREE_CODE (inner) == RESULT_DECL)
+	  && DECL_REGISTER (inner))
 	return;
       base = inner;
     }

